from tkinter import *
from DecisionTable import *

def drawTextTree(canvas,X,Y,STR):#■文字列表示
    canvas.create_text(X,Y,text=STR,
                       font=("Times",8),fill="black")
def drawLineTree(canvas,X1,Y1,X2,Y2,color="red"):#■線描画
    canvas.create_line(X1,Y1,X2,Y2,fill=color)
def drawBr1(canvas,X,Y,Cno,YesNo):#■直線による接続
    drawTextTree(canvas,X,Y,"C%d"% (Cno))
    drawLineTree(canvas,X+10,Y,X+40,Y)
    drawTextTree(canvas,X+20,Y-8,YesNo)
def drawBr2(canvas,X,Y,Y1,YesNo):#■折線による接続
    drawLineTree(canvas,X+10,Y,X+10,Y1)
    drawLineTree(canvas,X+10,Y1,X+40,Y1)
    drawTextTree(canvas,X+20,Y1-5,YesNo)
DLine=40
def drawTree(canvas, Tree,X):#■木構造表示
    global DLine
    if Tree[0]<0:#リーフ到達
        SS=strRuleStr(Tree); XX=X+len(SS)*4-10
        DLine+=26; drawTextTree(canvas,XX,DLine,SS)
        return DLine
    YY=0; YP=False; NP=False 
    if Tree[1]!=[]:# Yes方向
        Y1=drawTree(canvas, Tree[1],X+50);
        YY+=Y1;YP=True
    if Tree[2]!=[]:# No方向
        Y2=drawTree(canvas, Tree[2],X+50)
        YY+=Y2;NP=True
    if YP and NP:  # Yes/No 両方向があるとき
        YY/=2
        drawTextTree(canvas,X,YY,"C%d"% (Tree[0]))#条件
        drawBr2(canvas,X,YY,Y1,"Yes")# 上(Yes)
        drawBr2(canvas,X,YY,Y2,"No" )# 下(No)
    elif YP: drawBr1(canvas,X,YY,Tree[0],"Yes")# Yesのみ
    elif NP: drawBr1(canvas,X,YY,Tree[0],"No" )# Noのみ　
    if Tree[3]!=[]: # Don't care enty 処理
        Y2=YY;YY=drawTree(canvas, Tree[3],X)
        if YP or NP:
            drawLineTree(canvas,X,YY-8,X,Y2+8,color="blue")
    return YY

            
